pam_sm_open_session(3)

NAME
pam_sm_open_session, pam_sm_close_session - Service provider implementation for pam_open_session and pam_close_session respectively

SYNOPSIS

cc [ flag ... ] file ... -lpam [ library ... ]

#include <security/pam_appl.h>
#include <security/pam_modules.h>

int pam_sm_open_session(pam_handle_t *pamh, int flags, int argc, const char **argv);

int pam_sm_close_session(pam_handle_t *pamh, int flags, int argc, const char **argv);

DESCRIPTION
In response to a call to pam_open_session(3) and pam_close_session(3), the PAM framework calls pam_sm_open_session() and pam_sm_close_session(), respectively from the modules listed in the pam.conf(4) file. The session management provider supplies the back-end functionality for this interface function.

pam_sm_open_session() is called to initiate session management. pam_sm_close_session() is invoked when a session has terminated. The argument pamh is an authentication handle. The following flag may be set in the flags field:

    PAM_SILENT
        Session service should not generate any messages
The argc argument represents the number of module options passed in from the configuration file pam.conf(4). argv specifies the module options, which are interpreted and processed by the session management service. If an unknown option is passed in, an error should be logged through syslog(3) and the option ignored.

RETURN VALUES

Upon successful completion, PAM_SUCCESS should be returned. The following values may also be returned upon error:

    PAM_SESSION_ERR
        Can not make/remove an entry for the specified session

    PAM_IGNORE
        Ignore underlying session module regardless of whether the control flag is required, optional or sufficient

SEE ALSO
pam(3), pam_open_session(3), syslog(3), pam.conf(4)